        .386
        .MODEL FLAT,STDCALL
        locals
        jumps

        unicode=0
        include ..\w32.inc
        include 3dfx.inc

.DATA

;[--------==========================================================--------];
header1 db 'Glide 2x Demo1', 0
err1    db "Can't find VooDoo board!", 0

pt1     dd -100.0,-100.0
pt2     dd  100.0,-100.0
pt3     dd  100.0, 100.0 
pt4     dd -100.0, 100.0

centrex dd 320.0
centrey dd 240.0

point1  GrVertex < 60.5, 30.5,0.0, 255.0,  0.0,  0.0, 0.0,0.0,0.0>
point2  GrVertex <579.5, 30.5,0.0,   0.0,  0.0,255.0, 0.0,0.0,0.0>
point3  GrVertex <579.5,449.5,0.0,   0.0,255.0,  0.0, 0.0,0.0,0.0>
point4  GrVertex < 60.5,449.5,0.0, 255.0,255.0,255.0, 0.0,0.0,0.0>

angle   dd 0.00
angleinc dd 0.001
angleii dd  0.0001


buffer1 db 4000 dup(0)

.CODE

;[--------==========================================================--------];

main:
        call _grGlideInit@0             ; Init the Glide system.

        call _grSstQueryHardware@4, offset buffer1
        cmp eax, FXTRUE
         je fine1
        call MessageBox, 0, offset err1, offset header1, MB_OK
        call ExitProcess
fine1:
        call _grSstSelect@4, 0          ; Select a VooDoo subsystem.

        call _grSstWinOpen@28, NULL, \
                               GR_RESOLUTION_640x480, \
                               GR_REFRESH_60Hz, \
                               GR_COLORFORMAT_ARGB, \
                               GR_ORIGIN_LOWER_LEFT, \
                               2, \
                               0
;- Glide Window Open! -;

        call _grColorCombine@20, GR_COMBINE_FUNCTION_LOCAL, \
                                 GR_COMBINE_FACTOR_NONE, \
                                 GR_COMBINE_LOCAL_ITERATED, \
                                 GR_COMBINE_OTHER_NONE, \
                                 FXFALSE
        mov ecx, 1000
loope1: push ecx

        mov esi, offset pt1
        mov edi, offset point1
        call transpt

        mov esi, offset pt2
        mov edi, offset point2
        call transpt

        mov esi, offset pt3
        mov edi, offset point3
        call transpt

        mov esi, offset pt4
        mov edi, offset point4
        call transpt



        fld angle
        fadd angleinc
        fstp angle

        fld angleinc
        fadd angleii
        fstp angleinc

        call _grBufferClear@12, 0, 0, 0

        call _grDrawTriangle@12, offset point1, offset point2, offset point3

        call _grDrawTriangle@12, offset point3, offset point4, offset point1

        call _grBufferSwap@4, 1                 ; Swap buffers

        call sleep, 10

        pop ecx
        dec ecx
         jnz loope1

        call _grGlideShutdown@0

        call ExitProcess                ; Exit the main process

;[--------==========================================================--------];
transpt proc
        fld angle
        fsincos                 ; st(0) = cos(angle) ; st(1) = sin(angle)
        fmul dword ptr [esi]    ; st(0) = x * cos(angle)
        fxch st(1)
        fmul dword ptr [esi + 4]; st(1) = y * sin(angle)
        fxch st(1)
        fsubp st(1)             ; st(0) = x * cos(angle) - y * sin(angle)
        fadd centrex
        fstp dword ptr [edi].gx

        fld angle
        fsincos                 ; st(0) = cos(angle) ; st(1) = sin(angle)
        fmul dword ptr [esi + 4]; st(0) = y * cos(angle)
        fxch st(1)
        fmul dword ptr [esi]    ; st(1) = x * sin(angle)
        fxch st(1)
        faddp st(1)             ; st(0) = y * cos(angle) + x * sin(angle)
        fadd centrey
        fstp dword ptr [edi].gy
        ret
transpt endp

ends
        end main
